<?php
namespace MASCOTCOREMEDINOV\Shortcodes\AnimatedLayerAdvancedChildHolder;

use MASCOTCOREMEDINOV\Shortcodes\Lib;

/**
 * class SC_Animated_Layer_Advanced_Child_Holder
 * @package MASCOTCOREMEDINOV\Shortcodes\AnimatedLayerAdvancedChildHolder;
 */
class SC_Animated_Layer_Advanced_Child_Holder implements Lib\Mascot_Core_Medinov_Interface_Shortcodes {
	
	/**
	 * @var shortcode_base
	 */
	private $shortcode_base;

	/**
	 * construct
	 */
	public function __construct() {
		$this->shortcode_base = 'tm_animated_layer_advanced_child_holder';
		add_action('init', array($this, 'MapShortCodeVC'), 998);
	}

	/**
	 * Returns shortcode_base for shortcode
	 */
	public function getShortCodeBase() {
		return $this->shortcode_base;
	}

	/**
	 * Maps shortcode to Visual Composer
	 */
	public function MapShortCodeVC() {

		if(function_exists('vc_map')) {
			$vc_map = array(
				'name'		=> esc_html__( 'Animated Layer - Advanced Child Holder ', 'mascot-core' ),
				'base'		=>$this->shortcode_base,
				'category'	=> esc_html__( 'by TM', 'mascot-core' ),
				'icon'		=> 'mascot-vc-icons vc-icon-animated-layer-item',

				"as_child" => array('only' => 'tmvc_divided_multi_scrolling_slider'),
				'as_parent' => array('except' => ''),
				"content_element" => true,
				"show_settings_on_create" => false,
				"js_view" => 'VcColumnView',

		
				'show_settings_on_create' => true,
				'params'	=>array(
					array(
						'type'			=> 'dropdown',
						"heading"		=> esc_html__( "Image Animation Effect", 'mascot-core' ),
						"param_name"	=> "image_animation_effect",
						'value'			=> mascot_core_medinov_tm_custom_animation_class_list(),
						'save_always'   => true,
						'admin_label'   => true,
						'std'			=> 'move-up',
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Parent Wrapper Custom CSS class", 'mascot-core' ),
						"param_name"	=> "image_wrapper_custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Parent Wrapper Custom Inline Style", 'mascot-core' ),
						"param_name"	=> "image_wrapper_inline_style",
						"description"	=> esc_html__( 'Example: top: 12px; left: 100px;', 'mascot-core' ),
						'admin_label'   => true,
					),
					array(
						'type'			=> 'checkbox',
						"heading"		=> esc_html__( "Add Box Shadow?", 'mascot-core' ),
						"param_name"	=> "add_box_shadow",
						'description'   => '',
					),
					
					mascot_core_medinov_vc_add_css_editor(),

				)
			);
			vc_map( $vc_map );

			//Modify vc_map from themes
			if( function_exists('mascot_core_medinov_sc_animated_layer_advanced_child_holder_vc_map_modifier') ) {
				mascot_core_medinov_sc_animated_layer_advanced_child_holder_vc_map_modifier( $this->shortcode_base );
			}
		}
	}

	/**
	 * Renders shortcodes HTML
	 */
	public function render( $attr, $content = null ) {

		//Render Shortcode from themes
		if( function_exists('mascot_core_medinov_sc_animated_layer_advanced_child_holder_render') && function_exists('vc_map') ) {
			return mascot_core_medinov_sc_animated_layer_advanced_child_holder_render( $attr, $content );
		}
		
	}
}