<?php
namespace MASCOTCOREMEDINOV\Shortcodes\AnimatedLayerAdvanced;

use MASCOTCOREMEDINOV\Shortcodes\Lib;

/**
 * class SC_Animated_Layer_Advanced
 * @package MASCOTCOREMEDINOV\Shortcodes\AnimatedLayerAdvanced;
 */
class SC_Animated_Layer_Advanced implements Lib\Mascot_Core_Medinov_Interface_Shortcodes {
	
	/**
	 * @var shortcode_base
	 */
	private $shortcode_base;

	/**
	 * construct
	 */
	public function __construct() {
		$this->shortcode_base = 'tm_animated_layer_advanced';
		add_action('init', array($this, 'MapShortCodeVC'), 998);
	}

	/**
	 * Returns shortcode_base for shortcode
	 */
	public function getShortCodeBase() {
		return $this->shortcode_base;
	}

	/**
	 * Maps shortcode to Visual Composer
	 */
	public function MapShortCodeVC() {
    
		if(function_exists('vc_map')) {
			$vc_map = array(
				'name'		=> esc_html__( 'Animated Layer Images - Advanced', 'mascot-core' ),
				'base'		=>$this->shortcode_base,
				'category'	=> esc_html__( 'by TM', 'mascot-core' ),
				'icon'		=> 'mascot-vc-icons vc-icon-animated-layer',
				'as_parent' => array('only' => 'tm_animated_layer_advanced_item,tm_animated_layer_advanced_child_holder'),
				"js_view" => 'VcColumnView',
				'params'	=>array(
					array(
						'type'			=> 'textfield',
						"heading"		=> esc_html__( "Custom CSS class", 'mascot-core' ),
						"param_name"	=> "custom_css_class",
						"description"	=> esc_html__( 'To style particular content element.', 'mascot-core' ),
					),
					
					mascot_core_medinov_vc_add_css_editor(),

				)
			);
			vc_map( $vc_map );

			//Modify vc_map from themes
			if( function_exists('mascot_core_medinov_sc_animated_layer_advanced_vc_map_modifier') ) {
				mascot_core_medinov_sc_animated_layer_advanced_vc_map_modifier( $this->shortcode_base );
			}
		}
	}

	/**
	 * Renders shortcodes HTML
	 */
	public function render( $attr, $content = null ) {

		//Render Shortcode from themes
		if( function_exists('mascot_core_medinov_sc_animated_layer_advanced_render') && function_exists('vc_map') ) {
			return mascot_core_medinov_sc_animated_layer_advanced_render( $attr, $content );
		}
		
	}
}